/*
 *	main.c
 *
 *	zbsO}bs[ǂ
 *
 *	* Sun Nov 28 04:30:00 JST 2002 Naoyuki Sawa
 *	- 1st [XB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

#ifdef USE_MUSIC
#include "instdef2.c"
#endif /*USE_MUSIC*/

#ifdef USE_SPRITE
#define SPRITE_ SPRITE_INIT2
const SPRITE sprite_table[SPRITE_COUNT] = {
#include "sprite.h"
};
#undef SPRITE_
#endif /*USE_SPRITE*/

#define extern
#include "work.h"
#undef extern

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	for(;;) {
		if(demo_main() < 0) break;
		game_main();
	}

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceLCDDispStop();
#ifdef V_SCREEN
	pceLCDSetBuffer(_def_vbuff);
#else /*V_SCREEN*/
	pceLCDSetBuffer(vbuff);
#endif /*V_SCREEN*/
	pceAppSetProcPeriod(1000 / FPS);
	pcePadSetTrigMode(PP_MODE_SINGLE);
	pceLCDDispStart();

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init_2d(&render, &surface, 0, 0, 0, 0);

#if defined(TRACE_ON) && (TRACE_ON)
	/* WG[o͂J܂B */
	stderr_open(1/*WG[o̓j^ڑ҂()*/);
#endif /*TRACE_ON*/

#ifdef TURBO
	/* NbNEEFCgؑւ܂B */
	turbo(TURBO);
#endif /*TURBO*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_init();
#endif /*USE_GC*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_init(LDIRECT_INTERVAL);
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_MUSIC
	/* yCu܂B */
	music_loudness(1);
	loadInst(); /* uRandomism Zone(http://www8.plala.or.jp/randomism/)v́whFLbgver.2.10xgp */
	InitMusic();
#endif /*USE_MUSIC*/

	/* N[Abv֐o^B */
	atexit(app_exit);

	/* eNX`܂B */
#ifdef TEXTURE_LIST
	{
		typedef const unsigned char TEXTURE_DATA[];
		extern TEXTURE_DATA TEXTURE_LIST;
		texture_table_init(texture_table, sizeof texture_table / sizeof *texture_table, TEXTURE_LIST);
	}
#endif /*TEXTURE_LIST*/

#ifdef USE_SPRITE
	/* ȈՃXvCghCo܂B */
	sprite_init(&render, sprite_table, SPRITE_COUNT, texture_table, TEXTURE_COUNT);
#endif /*USE_SPRITE*/

/*{{AvP[VL̏*/
	srand(pceTimerGetCount());

	/* TEh`l̉ʒB */
	pceWaveSetChAtt(0, 0); /* M_MUS */
	pceWaveSetChAtt(1, 8); /* S_HOP */
	pceWaveSetChAtt(2, 6); /* S_GET */

	/* nCXRAB */
	//hiscore = 8000;
	//{[iXXe[WBoxA߂ɐݒB
	hiscore = 3000;

	/* BGWJB */
	{
		RENDER render;
		SURFACE surface;
		surface.w = 15 * 16;
		surface.h = 10 + 13 * 6;
		surface.vbuff = &bgbuff[0][0];
		render_init_2d(&render, &surface, 0, 0, 0, 0);
		render.context->texture = &texture_table[1/*BG*/];
		render_object(&render, 0, 0, 0, 0, 15 * 16, 10 + 13 * 6, 0);
	}
/*}}AvP[VL̏*/
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
#ifdef USE_MUSIC
	/* mɉyt~܂B
	 * TEh̒~̓CupceAppExit()ōsĂ̂ŁA
	 * ł͕Kv܂B
	 */
	StopMusic();
	music_loudness(0);
#endif /*USE_MUSIC*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_free();
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_free();
#endif /*USE_GC*/
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#ifdef QUICK_REPEAT
	static unsigned char rep[8]; /* I[gs[gJE^ */
#endif /*QUICK_REPEAT*/

	int x __attribute__((unused));
	int y __attribute__((unused));

#ifdef USE_PAUSE
	int pause;
	/* PAUSEbZ[Ẅ̃C[Wޔpobt@́A324oCgKvłB
	 * X^bNɎ̂͊댯łAstaticɎ̖̂ʂłB
	 * ŁAPAUSEɂ̂݃q[vmۂ邱Ƃɂ܂B
	 */
	//unsigned char save[PAUSE_H][PAUSE_W];
	unsigned char (*save)[PAUSE_W] = NULL/*x}*/;

	pause = 0;
	for(;;) {
#endif /*USE_PAUSE*/

#ifdef V_SCREEN
		{ /* vbuff(c)_def_vbuff()ϊ */
			unsigned char *dst, *src;
			dst = &_def_vbuff[0];     /* ]̉ʂ͍ォ瑖Jn܂ */
			src = &vbuff[DISP_X - 1]; /* ]̏cʂ͉Eォ瑖Jn܂ */
			for(x = DISP_X - 1; x >= 0; x--) {
				for(y = 0; y < DISP_Y; y++) {
					*dst = *src;
					dst += 1;      /* ʂEɑ܂ */
					src += DISP_X; /* cʂɑ܂ */
				}
				                            /* ʂ͊Ɏ̍sֈړĂ܂ */
				src -= DISP_X * DISP_Y + 1; /* cʂ̗̈ԏֈړ܂ */
			}
		}
#endif /*V_SCREEN*/
		pceLCDTrans();		/* ʍXV */
		yield();		/* VXe */
		joy = pcePadGet();	/* pbhԍXV */
#ifdef V_SCREEN
		joy = (joy & ~(PAD_LF | PAD_RI | PAD_UP | PAD_DN | /* cʗp͕ϊ */
			       TRG_LF | TRG_RI | TRG_UP | TRG_DN))
			| (joy & PAD_LF ? PAD_UP : 0)
			| (joy & PAD_RI ? PAD_DN : 0)
			| (joy & PAD_UP ? PAD_RI : 0)
			| (joy & PAD_DN ? PAD_LF : 0)
			| (joy & TRG_LF ? TRG_UP : 0)
			| (joy & TRG_RI ? TRG_DN : 0)
			| (joy & TRG_UP ? TRG_RI : 0)
			| (joy & TRG_DN ? TRG_LF : 0);
#endif /*V_SCREEN*/

#ifdef USE_PAUSE
		/* PAUSEB */
		if(joy & TRG_START) {
			pause = !pause;	/* PAUSEԐ؂ւ */
			if(pause) {	/* PAUSE IN */
				/* PAUSEbZ[W\̃C[WޔB */
				save = (unsigned char (*)[PAUSE_W])malloc(PAUSE_W * PAUSE_H); /* C[Wޔpobt@m */
				if(save == NULL) DIE();
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
					}
				}
			} else {	/* PAUSE OUT */
				/* PAUSEbZ[W\̃C[W𕜋AB */
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
				free(save); /* C[Wޔpobt@J */
			}
		}
		if(!pause) break;

		/* PAUSEbZ[W_ŕ\B */
		if(pceTimerGetCount() % 1000 < 750) {
			render_string_framed(&render, PAUSE_X, PAUSE_Y, PAUSE_STR, PAUSE_FONT, PAUSE_COLOR);
		} else {
			for(y = 0; y < PAUSE_H; y++) {
				for(x = 0; x < PAUSE_W; x++) {
					vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
				}
			}
		}
	}
#endif /*USE_PAUSE */

#ifdef QUICK_REPEAT
	/* I[gs[gB */
	for(x = 0; x < 8; x++) {
		y = 1 << x; /* PAD_* */
		if(QUICK_REPEAT_PADS & y) {
			if(joy & y) {
				if(rep[x] != 0xff) rep[x]++;
				if(rep[x] >= QUICK_REPEAT_DELAY) joy |= y << 8; /* TRG_* */
			} else {
				rep[x] = 0;
			}
		}
	}
#endif QUICK_REPEAT

	now++;	/* O[o^C}XV */
}

/****************************************************************************
 *	delay
 ****************************************************************************/

void
delay(int frame)
{
	while(frame > 0) {
		schedule();
		frame--;
	}
}

/****************************************************************************
 *	demo_main
 ****************************************************************************/

int
demo_main()
{
	int result = -1;
	int x;
	int y;

	for(;;) {
		schedule();

		/* X^[gHIH */
		if(joy & TRG_A) {
			result = 0;
			break;
		}
		if(joy & TRG_SELECT) {
			result = -1;
			break;
		}

		/* ^Cg\B */
		sprite_draw(0, 0, SPR_TITLE, 0);

		/* JnEhIB */
		if(joy & TRG_LF) init_round -=  1;
		if(joy & TRG_RI) init_round +=  1;
		if(joy & TRG_UP) init_round += 10;
		if(joy & TRG_DN) init_round -= 10;
		if(init_round < 0) init_round = 0;
		if(init_round > 99 - 1) init_round = 99 - 1;

		/* XRA\B */
		render_string_framed(&render, 1, 1, "1UP", 0x82, 0x331);
		render_printf_framed(&render, 1 + 4 * 3, 1,          0x82, 0x330, "%6d",   score < 999999 ?   score : 999999);
		render_string_framed(&render, DISP_X - 4 * 8 - 2, 1, "HI", 0x82, 0x331);
		render_printf_framed(&render, DISP_X - 4 * 6 - 2, 1, 0x82, 0x330, "%6d", hiscore < 999999 ? hiscore : 999999);

		/* vvg\B */
		x = (DISP_X - 4 * 8) / 2;
		y = DISP_Y - 32;
		render_string_framed(&render, x, y, " A START", 0x82, 0x330);
		y += 8;
		render_string_framed(&render, x, y, "SEL EXIT", 0x82, 0x330);

		/* JnEh\B */
		render_printf_framed(&render, DISP_X - 4 * 7 - 2, DISP_Y - 8, 0x82, 0x331, "ROUND%2d", init_round + 1);
	}

	if(!result) {
		s3m_play(M_ALL, 5);
		while(s3m_stat() > 0) {
			schedule();
		}
		delay(SEC(0.25));
	}

	return result;
}

/****************************************************************************
 *	
 ****************************************************************************/

/* AChO (}bs[) */
#define N_IDLE_DELAY	2	/* x=y=z=0,pat=0ێJEg */
#define N_IDLE	COUNTOF(p_idle)
const short p_idle[] = { 2,2,2,2,2 };

/* ړ (}bs[,~[L[Y,j[R) */
#define N_MOVE_DELAY	3	/* x=y=z=0,pat=0ێJEg */
#define N_MOVE	COUNTOF(p_move)
const short p_move[] = { 1,1,1,1,1,1,2,2,3,3,3,3,3,3,3,2,2 };

#define IDLE_Z	2	/* AChÕWv */
#define MOVE_Z	10	/* ړ̃Wv */

/* ~X (}bs[) */
#define N_MISS	COUNTOF(p_miss)
const short p_miss[] = { /* ɑO(SPR_M00+) */
	0,0,2,2,1,1,2,2, 0,0,2,2, 1,2, 0,2,1,2, 0,2,1,2, 0,2,1,2,
};

#define MAPPY_INIT_COL		0
#define MAPPY_INIT_ROW		5
#define MAPPY_INIT_DIR		DIR_DN
#define NYAMCO_INIT_COL		4
#define NYAMCO_INIT_ROW		5
#define NYAMCO_INIT_DIR1	DIR_UP
#define NYAMCO_INIT_DIR2	DIR_LF

#define MAPPY_IDLE_SPEED	fld(1.0 / (N_IDLE_DELAY + N_IDLE) * 0.5)

/* ʏړx x}bs[`j[R`~[L[Y łB */
#define MAPPY_MOVE_SPEED1	fld(1.0 / (N_MOVE_DELAY + N_MOVE) * 0.950)
#define MAPPY_MOVE_SPEED2	fld(1.0 / (N_MOVE_DELAY + N_MOVE) * 1.900)
#define NYAMCO_MOVE_SPEED	fld(1.0 / (N_MOVE_DELAY + N_MOVE) * 0.975)
#define MEWKIES_MOVE_SPEED	fld(1.0 / (N_MOVE_DELAY + N_MOVE) * 1.000)
#define ANCESTOR_INIT_SPEED	fld(1.0 / (N_MOVE_DELAY + N_MOVE) * 1.500)

#define HIT_TARGET		fld(0.15)
#define HIT_ENEMY		fld(0.2)

#define HURRY_SPEEDUP		SEC( 90) /* 130b */
#define HURRY_ANCESTOR		SEC(120) /* 200b */

/****************************************************************************
 *	round_init1
 ****************************************************************************/

void
round_init1(int round, int seed)
{
	int i;
	int j;
	int col;
	int row;

	/* ܂NA܂B */
	memset(&game, 0, sizeof(GAME));

	/* tB[hTCYݒ肵܂B */
	switch(round % 3) {
	case 0:       game.cols =  9; break;
	case 1:       game.cols = 13; break;
	default/*2*/: game.cols = 16; break;
	}
	game.rows = 6;

	/* TARGET܂B */
	for(i = 0; i < MAX_TARGET; i++) {
		for(;;) {
			col = RND16_RANGE(seed, 0, game.cols);
			row = RND16_RANGE(seed, 0, game.rows);

			/* MAPPY̏oʒu`ׂ͕sB */
			if(abs(col - MAPPY_INIT_COL) +
			   abs(row - MAPPY_INIT_ROW) <= 1) {
				continue;
			}

			/* TARGETƓʒu͕sB */
			for(j = 0; j < i; j++) {
				if((game.target[j].col == col) &&
				   (game.target[j].row == row)) {
					break;
				}
			}
			if(j < i) continue;

			break;
		}

		/* TARGET𐶐܂B */
		game.target[i].stat = TARGET_NORMAL;
		game.target[i].col = col;
		game.target[i].row = row;
		game.target[i].kind = i / 2;
	}
}

/****************************************************************************
 *	round_init2
 ****************************************************************************/

void
round_init2(int round, int seed)
{
	int i;
	int j;
	int n;
	int col;
	int row;

	/* GAME\̂̓NA܂!! */

	/* HURRY UP!NA܂B */
	game.hurry_cnt = 0;
	game.hurry = 0;

	/* 擾^[QbgƔ{NA܂B */
	game.kind = -1;
	game.mult = 0;

	/* MAPPY܂B */
	memset(&game.mappy, 0, sizeof game.mappy);
	game.mappy.stat = MAPPY_READY;
	game.mappy.col = MAPPY_INIT_COL;
	game.mappy.row = MAPPY_INIT_ROW;
	game.mappy.dir = MAPPY_INIT_DIR;

	/* NYAMCO܂B */
	memset(&game.nyamco, 0, sizeof game.nyamco);
	game.nyamco.stat = NYAMCO_READY;
	game.nyamco.col = NYAMCO_INIT_COL;
	game.nyamco.row = NYAMCO_INIT_ROW;
	game.nyamco.dir1 = NYAMCO_INIT_DIR1;
	game.nyamco.dir2 = NYAMCO_INIT_DIR2;

	/* MEWKIES܂B */
	memset(&game.mewkies, -1/*MEWKIES_BLANK*/, sizeof game.mewkies);
	n = (1 + round) * game.cols / 9;
	if(n > MAX_MEWKIES) n = MAX_MEWKIES;
	for(i = 0; i < n; i++) {
		for(;;) {
			col = RND16_RANGE(seed, 0, game.cols);
			row = RND16_RANGE(seed, 0, game.rows);

			/* MAPPY̏oʒu`ׂ͕sB */
			if(abs(col - MAPPY_INIT_COL) +
			   abs(row - MAPPY_INIT_ROW) <= 2) {
				continue;
			}

			/* NYAMCȌoʒu͕sB */
			if(abs(col - NYAMCO_INIT_COL) +
			   abs(row - NYAMCO_INIT_ROW) <= 0) {
				continue;
			}

			/* MEWKIESƓʒu͕sB */
			for(j = 0; j < i; j++) {
				if((game.mewkies[j].col == col) &&
				   (game.mewkies[j].row == row)) {
					break;
				}
			}
			if(j < i) continue;

			break;
		}

		/* MEWKIES𐶐܂B */
		game.mewkies[i].stat = MEWKIES_READY;
		game.mewkies[i].col = col;
		game.mewkies[i].row = row;
		game.mewkies[i].dir = RND16_RANGE(seed, 0, 4);
	}

	/* ANCESTORNA܂B */
	memset(&game.ancestor, -1/*ANCESTOR_BLANK*/, sizeof game.ancestor);

	/* TARGET|Cg\Ȃ΁A܂B
	 * round_init1()Ă΂ꂽꍇ́A_~[ƂȂ܂B
	 */
	for(i = 0; i < MAX_TARGET; i++) {
		if(game.target[i].stat == TARGET_POINT) {
			game.target[i].stat = TARGET_BLANK;
		}
	}

	/* XN[AOBJ܂B */
	game.scroll = 0;
	game.objnum = 0;
}

/****************************************************************************
 *	game_init
 ****************************************************************************/

void
game_init()
{
	score = 0;
	round = init_round;
	life = 3 - 1;
}

/****************************************************************************
 *	game_main
 ****************************************************************************/

static void
round_ready(int round, int seed)
{
	int i;
	int t0;
	int t1;

	s3m_play(M_ALL, 1);
	t0 = pceTimerGetCount();
	round_init2(round, seed);

	for(;;) {
		schedule();

		/* Ă}bs[ */
		t1 = pceTimerGetCount();
		i = (3800 - (t1 - t0)) / FPS;
		if(i <= 0) {
			break;
		}
		game.mappy.cnt = fimul(fld(i), 3);
		update(UPDATE_ALL & ~UPDATE_FIX);

		/* J */
		i -= SEC(1.7);
		if(i < 0) {
			continue;
		}
		if(i > DISP_X / 3) {
			i = DISP_X / 3;
		}
		i = i * 3 - DISP_X + 2;
		render_rectangle_fill(&render, i, 0, DISP_X, DISP_Y, 3);
		render_string(&render, (DISP_X - 4 * 20) / 2 + i, (DISP_Y - 6) / 2,
			"HOP TO IT PLAYER ONE", 0x82, 0);
		update(UPDATE_FIX);
	}

	/* Jn҂ */
	if(game.mappy.stat != MAPPY_READY) DIE();
	game.mappy.stat = MAPPY_IDLE; /* MOVEł͂Ȃ!! */
	//
	if(game.nyamco.stat != NYAMCO_READY) DIE();
	game.nyamco.stat = NYAMCO_MOVE;
	//
	for(i = 0; i < MAX_MEWKIES; i++) {
		if(game.mewkies[i].stat == MEWKIES_BLANK) continue;
		if(game.mewkies[i].stat != MEWKIES_READY) DIE();
		game.mewkies[i].stat = MEWKIES_MOVE;
	}
}

static void
round_miss()
{
	s3m_stop();
	update(UPDATE_ALL);
	delay(SEC(0.4));

	s3m_play(M_ALL, 3);
	game.mappy.stat = MAPPY_MISS;
	game.mappy.cnt = fld(0);
	while(s3m_stat() > 0) {
		schedule();
		update(UPDATE_MAPPY | UPDATE_BG | UPDATE_FIX);
	}
}

static void
round_clear()
{
	s3m_stop();
	update(UPDATE_ALL);
	delay(SEC(0.4));

	s3m_play(M_ALL, 2);
	game.mappy.stat = MAPPY_CLEAR;
	game.mappy.cnt = fld(0);
	while(s3m_stat() > 0) {
		schedule();
		update(UPDATE_MAPPY | UPDATE_BG | UPDATE_FIX);
	}
}

static void
gameover()
{
	delay(SEC(0.5));

	s3m_play(M_ALL, 4);
	while(s3m_stat() > 0) {
		schedule();
		update(UPDATE_ENEMY | UPDATE_FIX);
		render_string(&render, (DISP_X - 4 * 11) / 2, (DISP_Y - 6 * 3) / 2 - 6, "PLAYER  ONE", 0x82, 0);
		render_string(&render, (DISP_X - 4 * 11) / 2, (DISP_Y - 6 * 3) / 2 + 6, " GAME OVER ", 0x82, 0);
	}
	s3m_stop();

	delay(SEC(0.5));
}

void
game_main()
{
	int x;
	int y;
	int w;
	int h;
	int round_seed;

	/* Q[B */
	game_init();

L_START:
	/* EhB */
	round_seed = pceTimerGetCount();
	round_init1(round, round_seed ^ -1);

L_RESTART:
	/* X^[gB */
	round_ready(round, round_seed);
	for(;;) {
		schedule();

		/* Ԑ؂Xs[hAbvB */
		game.hurry_cnt++;
		if(game.hurry_cnt >= HURRY_SPEEDUP) {
			if(!game.hurry) {
				game.hurry = 1;
				w = 4 * 10;
				h = 6 - 1;
				x = (DISP_X - w) / 2;
				y = (DISP_Y - h) / 2;
				render_rectangle_fill(&render, x - 3, y - 5    , w + 3 * 2, h + 5 * 2    , 3);
				render_rectangle_fill(&render, x    , y - 5 - 1, w        , h + 5 * 2 + 2, 3);
				render_rectangle_fill(&render, x - 2, y - 4    , w + 2 * 2, h + 4 * 2    , 1);
				render_string(&render, x, y, " HURRY UP!", 0x82, 3);
				s3m_play(M_ALL, 8);
				while(s3m_stat() > 0) {
					schedule();
				}
				s3m_play(M_ALL, 9);
			}
		}
		/* cloAXs[hAbvB */
		if(game.hurry_cnt >= HURRY_ANCESTOR) {
			if(game.ancestor.stat == ANCESTOR_BLANK) {
				game.ancestor.stat = ANCESTOR_MOVE;
				game.ancestor.cnt = fld(0);
				game.ancestor.col = game.cols / 2;
				game.ancestor.row = game.rows; /* ʊO */
				game.ancestor.dir = DIR_UP;
				game.ancestor.speed = ANCESTOR_INIT_SPEED;
			} else {
				if(!(game.hurry_cnt % SEC(1))) {
					game.ancestor.speed = fmul(game.ancestor.speed, fld(1.02));
				}
			}
		}

		/* ړA\B */
		update(UPDATE_ALL);

		/* 蔻B */
		if(ht_target()) {
			goto L_CLEAR;
		}
		if(ht_enemy()) {
			goto L_MISS;
		}
	}

L_CLEAR:
	/* EhNAB */
	round_clear();
	round++;
	goto L_START;

L_MISS:
	/* }bs[E~XB */
	round_miss();
	if(life > 0) {
		life--;
		goto L_RESTART;
	}

	/* Q[I[o[B */
	gameover();
}

/****************************************************************************
 *	update
 ****************************************************************************/

void
update(int mask)
{
	int i;
	const unsigned char* src;
	      unsigned char* dst;

	if(mask == UPDATE_FIX) {
		goto L_FIXONLY;
	}

	if(mask & UPDATE_MAPPY) {
		mappy_action();
	}
	if(mask & UPDATE_ENEMY) {
		for(i = 0; i <= game.hurry; i++) {
			nyamco_action();
			mewkies_action();
		}
		ancestor_action();
	}
	if(mask & UPDATE_TARGET) {
		target_action();
	}
	if(mask & UPDATE_BG) {
		//sprite_draw(game.scroll, 0, SPR_BG, DRW_NOMAL);
		//̂߁A炩ߓWJB
		i = -game.scroll;
		if(i < 0) i = 0; /* Ô */
		if(i > 15 * 16 - DISP_X) i = 15 * 16 - DISP_X; /* Ô */
		src = &bgbuff[0][i];
		dst = vbuff;
		for(i = 0; i < DISP_Y; i++) {
			memcpy(dst, src, DISP_X);
			src += 15 * 16;
			dst += DISP_X;
		}
	} else {
		memset(vbuff, 3, sizeof vbuff);
	}

	obj_disp();

L_FIXONLY:
	if(score > hiscore) {
		hiscore = score;
	}
	if(now % SEC(0.7) < SEC(0.4)) {
		render_string_framed(&render, 1, 1, "1UP", 0x82, 0x331);
	}
	render_printf_framed(&render, 1 + 4 * 3, 1,          0x82, 0x330, "%6d",   score < 999999 ?   score : 999999);
	render_string_framed(&render, DISP_X - 4 * 8 - 2, 1, "HI", 0x82, 0x331);
	render_printf_framed(&render, DISP_X - 4 * 6 - 2, 1, 0x82, 0x330, "%6d", hiscore < 999999 ? hiscore : 999999);
	if(life < 2) {
		render_printf_framed(&render, 1, DISP_Y - 8, 0x82, 0x331, "%d LIFE LEFT", life > 0 ? life : 0);
	} else {
		render_printf_framed(&render, 1, DISP_Y - 8, 0x82, 0x331, "%d LIVES LEFT", life > 0 ? life : 0);
	}
	render_printf_framed(&render, DISP_X - 4 * 7 - 2, DISP_Y - 8, 0x82, 0x331, "ROUND%2d", round + 1 < 99 ? round + 1 : 99);
}

/****************************************************************************
 *	ht_target
 ****************************************************************************/

int
ht_target()
{
	const fixed mappy_x = game.mappy.x;
	const fixed mappy_y = game.mappy.y;
	//
	int i_target;
	TARGET* target;
	fixed dx;
	fixed dy;

	/* }bs[ƃ^[Qbg̓蔻s܂B */
	for(i_target = 0, target = game.target;
	    i_target < MAX_TARGET;
	    i_target++, target++) {

		if(target->stat != TARGET_NORMAL) continue; /* 󂫂܂̓|Cg\ */

		/* dȂĂ... */
		dx = ffabs(fsub(target->x, mappy_x));
		dy = ffabs(fsub(target->y, mappy_y));
		if(fcom(dx, <=, HIT_TARGET) &&
		   fcom(dy, <=, HIT_TARGET)) {

			/* {AbvAXRAZA^[QbgNAB */
			target->stat = TARGET_POINT;
			if(target->kind == game.kind) {
				game.mult++;
				score += (1 + target->kind) * 10 * (1 + game.mult);
				target->mult = game.mult;
			} else {
				score += (1 + target->kind) * 10;
				game.kind = target->kind; /* ̂߂ */
				target->mult = 0;
			}
			sound_play(2, S_GET);
		}
	}

	/* SẴ^[QbgNAA0ȊO̒lԂ܂B */
	for(i_target = 0, target = game.target;
	    i_target < MAX_TARGET;
	    i_target++, target++) {
		if(target->stat == TARGET_NORMAL) break;
	}
	return i_target == MAX_TARGET;
}

/****************************************************************************
 *	ht_enemy
 ****************************************************************************/

int
ht_enemy()
{
	const fixed mappy_x = game.mappy.x;
	const fixed mappy_y = game.mappy.y;
	//
	int i_mewkies;
	MEWKIES* mewkies;
	fixed dx;
	fixed dy;

	/* }bs[ƃj[R̓蔻s܂B */
	dx = ffabs(fsub(game.nyamco.x, mappy_x));
	dy = ffabs(fsub(game.nyamco.y, mappy_y));
	if(fcom(dx, <=, HIT_ENEMY) &&
	   fcom(dy, <=, HIT_ENEMY)) {

		switch(game.nyamco.stat) {
		case NYAMCO_MOVE:
			/* }bs[E~XB */
			return 1;

		case NYAMCO_REST:
			/* j[RE_EB */
			if(!game.nyamco.rest_cnt) { /* _E */
				game.nyamco.stat = NYAMCO_DOWN;
				game.nyamco.cnt = fld(0);
				score += 100;
			}
			break;

		default:
			/** no job **/
			break;
		}
	}

	/* }bs[ƃ~[L[Y̓蔻s܂B */
	for(i_mewkies = 0, mewkies = game.mewkies;
	    i_mewkies < MAX_MEWKIES;
	    i_mewkies++, mewkies++) {

		if(mewkies->stat == MEWKIES_BLANK) continue; /*  */

		dx = ffabs(fsub(mewkies->x, mappy_x));
		dy = ffabs(fsub(mewkies->y, mappy_y));
		if(fcom(dx, <=, HIT_ENEMY) &&
		   fcom(dy, <=, HIT_ENEMY)) {
			return 1;
		}
	}

	/* }bs[Ƃcl̓蔻s܂B */
	if(game.ancestor.stat != ANCESTOR_BLANK) {
		dx = ffabs(fsub(game.ancestor.x, mappy_x));
		dy = ffabs(fsub(game.ancestor.y, mappy_y));
		if(fcom(dx, <=, HIT_ENEMY) &&
		   fcom(dy, <=, HIT_ENEMY)) {
			return 1;
		}
	}

	return 0;
}

/****************************************************************************
 *	obj_put
 ****************************************************************************/

void
obj_put(fixed x, fixed y, fixed z, int sprno)
{
	OBJ* obj;

	/* ɓo^EȂ΁A܂B */
	if(game.objnum >= MAX_OBJS) {
		return;
	}

	/* o^܂B */
	obj = &game.objs[game.objnum++];
	obj->x = x;
	obj->y = y;
	obj->z = z;
	obj->sprno = sprno;
}

/****************************************************************************
 *	obj_disp
 ****************************************************************************/

static int
obj_comp(const void* _a, const void* _b)
{
	const OBJ* a = _a;
	const OBJ* b = _b;

	/* 1. y()=ɕ`Ay傫(O)=ŕ`
	 * 2. z()=ɕ`Az傫()=ŕ`
	 */
	if(fcom(a->y, <, b->y)) return -1;
	if(fcom(a->y, >, b->y)) return  1;
	if(fcom(a->z, <, b->z)) return -1;
	if(fcom(a->z, >, b->z)) return  1;

	/* j[R^[QbgɏdȂċxeꍇ̂߂ */
	return b->sprno - a->sprno;
}

void
obj_disp()
{
	int i;
	int x;
	int y;
	OBJ* obj;

	/* ёւB */
	qsort(game.objs, game.objnum, sizeof(OBJ), obj_comp);

	/* e`܂B */
	for(i = 0, obj = game.objs;
	    i < game.objnum;
	    i++, obj++) {
		if(obj->sprno >= SPR_S00) continue; /* e */
		map_point(&x, &y, obj->x, obj->y, 0);
		sprite_draw(x, y, ficom(obj->z, ==, 0) ? SPR_S00 : SPR_S01, DRW_NOMAL);
	}

	/* {̂`܂B */
	for(i = 0, obj = game.objs;
	    i < game.objnum;
	    i++, obj++) {
		map_point(&x, &y, obj->x, obj->y, obj->z);
		sprite_draw(x, y, obj->sprno, DRW_NOMAL);
	}

	/* ̂߂ɓo^܂B */
	game.objnum = 0;
}

/****************************************************************************
 *	map_point
 ****************************************************************************/

void
map_point(int* dx, int* dy, fixed lx, fixed ly, fixed lz)
{
	*dx = fist(fadd(     fimul(lx, CELL_W)     , fld(CELL_W / 2 + 0.5))) + game.scroll;
	*dy = fist(fadd(fsub(fimul(ly, CELL_H), lz), fld(CELL_H / 2 + 0.5))) + 10;
}

/****************************************************************************
 *	mappy_action
 ****************************************************************************/

void
mappy_action()
{
	MAPPY* mappy = &game.mappy;
	int redo;
	int sprno;
	int i_pat;
	int x;
	int y;
	fixed f;

	if(1) {
		redo = 0;
	} else {
L_REDO:		redo = 1;
	}

	/* XvCgƍW߂Ă܂B */
	sprno = SPR_M00 + mappy->dir * 4;
	mappy->x = fld(mappy->col);
	mappy->y = fld(mappy->row);
	mappy->z = fld(0);

	/* Ԃɂ... */
	switch(mappy->stat) {

	/*** EhJn ***/
	case MAPPY_READY:

		/* O\A̓C[`cntɂĎwB */
		sprno = sprno = SPR_M00;
		mappy->z = mappy->cnt;

		break;

	/*** AChO ***/
	case MAPPY_IDLE:

		/* ړJn薳Ԃ̂߂ɁA͂ێĂ܂B */
		mappy->joy |= joy;

		/* JE^i߂܂B */
		if(!redo) {
			mappy->cnt = fadd(mappy->cnt, MAPPY_IDLE_SPEED);
		}
		while(ficom(mappy->cnt, >=, 1)) {
			mappy->cnt = fisub(mappy->cnt, 1);
		}

		/* p^[isɂ... */
		i_pat = fist(fimul(mappy->cnt, N_IDLE_DELAY + N_IDLE)) - N_IDLE_DELAY;
		if(i_pat < 0) {
			/* ړJns܂B(ێĂ͂g) */
			if((mappy->joy & PAD_DN) && (mappy->row < game.rows - 1)) {
				mappy->joy = 0;
				mappy->stat = MAPPY_MOVE;
				mappy->cnt = fld(0);
				mappy->dir = DIR_DN;
				goto L_REDO;
			}
			if((mappy->joy & PAD_UP) && (mappy->row > 0)) {
				mappy->joy = 0;
				mappy->stat = MAPPY_MOVE;
				mappy->cnt = fld(0);
				mappy->dir = DIR_UP;
				goto L_REDO;
			}
			if((mappy->joy & PAD_RI) && (mappy->col < game.cols - 1)) {
				mappy->joy = 0;
				mappy->stat = MAPPY_MOVE;
				mappy->cnt = fld(0);
				mappy->dir = DIR_RI;
				goto L_REDO;
			}
			if((mappy->joy & PAD_LF) && (mappy->col > 0)) {
				mappy->joy = 0;
				mappy->stat = MAPPY_MOVE;
				mappy->cnt = fld(0);
				mappy->dir = DIR_LF;
				goto L_REDO;
			}
		} else {
			/* XvCgƍW𒲐܂B */
			sprno += p_idle[i_pat];
			f = fimul(fsin(fidiv(fimul(PI, i_pat), N_IDLE)), IDLE_Z);
			mappy->z = fadd(mappy->z, f);
		}

		break;

	/*** ړ(Oi) ***/
	case MAPPY_MOVE:

		/* JE^i߂܂B */
		if(!redo) {
			f = mappy->cnt;
			if(!(joy & PAD_AB)) {
				mappy->cnt = fadd(mappy->cnt, MAPPY_MOVE_SPEED1);
			} else {
				mappy->cnt = fadd(mappy->cnt, MAPPY_MOVE_SPEED2);
			}
			/* ړJn㏭xČʉB */
			if(fcom(         f, < , fld(0.3)) &&
			   fcom(mappy->cnt, >=, fld(0.3))) {
				sound_play(1, S_HOP);
			}
		}

		/* p^[isɂ... */
		i_pat = fist(fimul(mappy->cnt, N_MOVE_DELAY + N_MOVE)) - N_MOVE_DELAY;
		if(i_pat < 0) {
			/** no job **/
		} else if(i_pat < N_MOVE) {
			/* ފJns܂B */
			if(((mappy->dir == DIR_DN) && (joy & PAD_UP)) ||
			   ((mappy->dir == DIR_UP) && (joy & PAD_DN)) ||
			   ((mappy->dir == DIR_LF) && (joy & PAD_RI)) ||
			   ((mappy->dir == DIR_RI) && (joy & PAD_LF))) {
				mappy->stat = MAPPY_BACK;
				goto L_REDO;
			}
			/* XvCgƍW𒲐܂B */
			sprno += p_move[i_pat];
			f = fidiv(fld(i_pat), N_MOVE);
			switch(mappy->dir) {
			case DIR_DN: mappy->y = fadd(mappy->y, f); break;
			case DIR_UP: mappy->y = fsub(mappy->y, f); break;
			case DIR_LF: mappy->x = fsub(mappy->x, f); break;
			case DIR_RI: mappy->x = fadd(mappy->x, f); break;
			default: DIE();
			}
			f = fimul(fsin(fidiv(fimul(PI, i_pat), N_MOVE)), MOVE_Z);
			mappy->z = fadd(mappy->z, f);
		} else {
			/* ړ(Oi)܂B */
			switch(mappy->dir) {
			case DIR_DN: mappy->row++; break;
			case DIR_UP: mappy->row--; break;
			case DIR_LF: mappy->col--; break;
			case DIR_RI: mappy->col++; break;
			default: DIE();
			}
			mappy->stat = MAPPY_IDLE;
			mappy->cnt = fld(0);
			goto L_REDO;
		}

		break;

	/*** ړ() ***/
	case MAPPY_BACK:

		/* JE^߂܂B */
		if(!redo) {
			if(!(joy & PAD_AB)) {
				mappy->cnt = fsub(mappy->cnt, MAPPY_MOVE_SPEED1);
			} else {
				mappy->cnt = fsub(mappy->cnt, MAPPY_MOVE_SPEED2);
			}
			/* ނ͌ʉ܂B */
		}

		/* p^[isɂ... */
		i_pat = fist(fimul(mappy->cnt, N_MOVE_DELAY + N_MOVE)) - N_MOVE_DELAY;
		if(i_pat < 0) {
			/* ړ()܂B */
			mappy->stat = MAPPY_IDLE;
			mappy->cnt = fld(0);
			goto L_REDO;
		} else {
			/* XvCgƍW𒲐܂B */
			sprno += p_move[N_MOVE - 1 - i_pat]; /* JE^͌łAAj[V͑OiƓ̕ωł!! */
			f = fidiv(fld(i_pat), N_MOVE);
			switch(mappy->dir) {
			case DIR_DN: mappy->y = fadd(mappy->y, f); break;
			case DIR_UP: mappy->y = fsub(mappy->y, f); break;
			case DIR_LF: mappy->x = fsub(mappy->x, f); break;
			case DIR_RI: mappy->x = fadd(mappy->x, f); break;
			default: DIE();
			}
			f = fimul(fsin(fidiv(fimul(PI, i_pat), N_MOVE)), MOVE_Z);
			mappy->z = fadd(mappy->z, f);
		}

		break;

	/*** EhNA ***/
	case MAPPY_CLEAR:

		/* Ō̕\ێ܂B */
		mappy->x = mappy->last_x;
		mappy->y = mappy->last_y;
		mappy->z = mappy->last_z;
		sprno = mappy->last_sprno;

		break;

	/*** ~X ***/
	case MAPPY_MISS:

		/* JE^i߂܂B */
		mappy->cnt = fiadd(mappy->cnt, 1);

		/* XvCg͏ɑOłB */
		sprno = SPR_M00;

		/* p^[isɂ... */
		i_pat = fist(mappy->cnt) / 2;
		if(i_pat > N_MISS - 1) {
			i_pat = N_MISS - 1;
		}
		sprno += p_miss[i_pat];

		/* Ō̈ʒuێ܂B */
		mappy->x = mappy->last_x;
		mappy->y = mappy->last_y;
		mappy->z = mappy->last_z;

		break;

	default:
		DIE();
	}

	/* OBJo^܂B */
	obj_put(mappy->x, mappy->y, mappy->z, sprno);

	/* ŏI\ʒuƃXvCgԍLĂ܂B(EhNÂ) */
	mappy->last_x = mappy->x;
	mappy->last_y = mappy->y;
	mappy->last_z = mappy->z;
	mappy->last_sprno = sprno;

	/* ʃXN[𒲐܂B */
	map_point(&x, &y, mappy->x, mappy->y, mappy->z);
	game.scroll += DISP_X / 2 - x;
	if(game.scroll > 0) {
		game.scroll = 0;
	}
	if(game.scroll < DISP_X - game.cols * CELL_W) {
		game.scroll = DISP_X - game.cols * CELL_W;
	}
}

/****************************************************************************
 *	nyamco_action
 ****************************************************************************/

void
nyamco_action()
{
	NYAMCO* nyamco = &game.nyamco;
	int redo;
	int sprno;
	int i_pat;
	fixed f;

	if(1) {
		redo = 0;
	} else {
L_REDO:			redo = 1;
	}

	/* XvCgƍW߂Ă܂B */
	sprno = SPR_N00 + nyamco->dir1 * 4;
	nyamco->x = fld(nyamco->col);
	nyamco->y = fld(nyamco->row);
	nyamco->z = fld(0);

	/* Ԃɂ... */
	switch(nyamco->stat) {

	/*** EhJn ***/
	case NYAMCO_READY:

		/* OÎ~ێ܂B */
		sprno = sprno = SPR_N00;

		break;

	/*** ړ ***/
	case NYAMCO_MOVE:

		/* JE^i߂܂B */
		if(!redo) {
			nyamco->cnt = fadd(nyamco->cnt, NYAMCO_MOVE_SPEED);
		}

		/* p^[isɂ... */
		i_pat = fist(fimul(nyamco->cnt, N_MOVE_DELAY + N_MOVE)) - N_MOVE_DELAY;
		if(i_pat < 0) {
			/* ]s܂B */
			switch(nyamco->dir1) {
			case DIR_DN:
				if(nyamco->row >= game.rows - 1) {
					nyamco->dir1 = nyamco->dir2;
					goto L_REDO;
				}
				break;
			case DIR_UP:
				if(nyamco->row <= 0) {
					nyamco->dir1 = nyamco->dir2;
					goto L_REDO;
				}
				break;
			case DIR_LF:
				if(nyamco->col <= 0) {
					nyamco->dir1 = DIR_RI;
					nyamco->dir2 = DIR_RI;
					goto L_REDO;
				}
				break;
			case DIR_RI:
				if(nyamco->col >= game.cols - 1) {
					nyamco->dir1 = DIR_LF;
					nyamco->dir2 = DIR_LF;
					goto L_REDO;
				}
				break;
			default:
				DIE();
			}
		} else if(i_pat < N_MOVE) {
			/* XvCgƍW𒲐܂B */
			sprno += p_move[i_pat];
			f = fidiv(fld(i_pat), N_MOVE);
			switch(nyamco->dir1) {
			case DIR_DN: nyamco->y = fadd(nyamco->y, f); break;
			case DIR_UP: nyamco->y = fsub(nyamco->y, f); break;
			case DIR_LF: nyamco->x = fsub(nyamco->x, f); break;
			case DIR_RI: nyamco->x = fadd(nyamco->x, f); break;
			default: DIE();
			}
			f = fimul(fsin(fidiv(fimul(PI, i_pat), N_MOVE)), MOVE_Z);
			nyamco->z = fadd(nyamco->z, f);
		} else {
			/* xe? */
			nyamco->rest_cnt++;
			if(nyamco->rest_cnt >= 15) {
				nyamco->stat = NYAMCO_REST;
				nyamco->cnt = fld(0);
				/* rest_cnt͂܂NA܂ */
				nyamco->last_dir = nyamco->dir1;
				/* FALL THRU */
			}
			/* 1Z̈ړ܂B */
			nyamco->cnt = fld(0);
			switch(nyamco->dir1) {
			case DIR_DN:
				nyamco->row++;
				/* ړƐÍAL_REDOɏōs܂B */
				break;
			case DIR_UP:
				nyamco->row--;
				/* ړƐÍAL_REDOɏōs܂B */
				break;
			case DIR_LF:
				nyamco->col--;
				/* ړ1ZړŐړցB */
				if(nyamco->row <= 0) {
					nyamco->dir1 = DIR_DN;
				} else {
					nyamco->dir1 = DIR_UP;
				}
				break;
			case DIR_RI:
				nyamco->col++;
				/* ړ1ZړŐړցB */
				if(nyamco->row <= 0) {
					nyamco->dir1 = DIR_DN;
				} else {
					nyamco->dir1 = DIR_UP;
				}
				break;
			default:
				DIE();
			}
			goto L_REDO;
		}

		break;

	/*** xe ***/
	case NYAMCO_REST:

		nyamco->cnt = fiadd(nyamco->cnt, 1);
		i_pat = fist(nyamco->cnt);
		if(i_pat < 16) {
			sprno = SPR_N00 + nyamco->last_dir * 4 + 3;
		} else if(i_pat < 16 + (32 * 2 + 16)) {
			sprno = SPR_N10 + ((i_pat / 4) & 1);
			nyamco->rest_cnt = 0; /* _E */
		} else if(i_pat < 16 + (32 * 2 + 16) + (32 * 2 + 16)) {
			sprno = SPR_N10 + ((i_pat / 8) & 1);
		} else if(i_pat < 16 + (32 * 2 + 16) + (32 * 2 + 16) + 16) {
			sprno = SPR_N10;
		} else {
			nyamco->stat = NYAMCO_MOVE;
			nyamco->cnt = fld(0);
			nyamco->rest_cnt = 0; /* ȂĂ... */
		}
		break;

	/*** _E ***/
	case NYAMCO_DOWN:

		nyamco->cnt = fiadd(nyamco->cnt, 1);
		i_pat = fist(nyamco->cnt);
		if(i_pat < SEC(0.75)) {
			sprno = nyamco->last_sprno;
		} else if(i_pat < SEC(0.75) + 4 * 4) {
			sprno = SPR_N14 + (i_pat - SEC(0.75)) / 4;
		} else if(i_pat < SEC(0.75) + 4 * 4 + SEC(1.5)) {
			sprno = SPR_N17;
		} else {
			nyamco->stat = NYAMCO_MOVE;
			nyamco->cnt = fld(0);
			nyamco->rest_cnt = 0; /* Kv!! */
		}
		break;

	default:
		DIE();
	}

	/* OBJo^܂B */
	obj_put(nyamco->x, nyamco->y, nyamco->z, sprno);

	/* ŏI\XvCgԍL܂B */
	nyamco->last_sprno = sprno;
}

/****************************************************************************
 *	mewkies_action
 ****************************************************************************/

void
mewkies_action()
{
	MEWKIES* mewkies;
	int i_mewkies;
	int redo;
	int sprno;
	int i_pat;
	fixed f;

	for(i_mewkies = 0, mewkies = game.mewkies;
	    i_mewkies < MAX_MEWKIES;
	    i_mewkies++, mewkies++) {

		if(1) {
			redo = 0;
		} else {
L_REDO:			redo = 1;
		}

		if(mewkies->stat == MEWKIES_BLANK) continue; /*  */

		/* XvCgƍW߂Ă܂B */
		sprno = SPR_K00 + mewkies->dir * 4;
		mewkies->x = fld(mewkies->col);
		mewkies->y = fld(mewkies->row);
		mewkies->z = fld(0);

		/* Ԃɂ... */
		switch(mewkies->stat) {

		/*** EhJn ***/
		case MEWKIES_READY:

			/* OÎ~ێ܂B */
			sprno = sprno = SPR_K00;

			break;

		/*** ړ ***/
		case MEWKIES_MOVE:

			/* JE^i߂܂B */
			if(!redo) {
				mewkies->cnt = fadd(mewkies->cnt, MEWKIES_MOVE_SPEED);
			}

			/* p^[isɂ... */
			i_pat = fist(fimul(mewkies->cnt, N_MOVE_DELAY + N_MOVE)) - N_MOVE_DELAY;
			if(i_pat < 0) {
				/* ]s܂B */
				switch(mewkies->dir) {
				case DIR_DN:
					if(mewkies->row >= game.rows - 1) {
						mewkies->dir = DIR_UP;
						goto L_REDO;
					}
					break;
				case DIR_UP:
					if(mewkies->row <= 0) {
						mewkies->dir = DIR_DN;
						goto L_REDO;
					}
					break;
				case DIR_LF:
					if(mewkies->col <= 0) {
						mewkies->dir = DIR_RI;
						goto L_REDO;
					}
					break;
				case DIR_RI:
					if(mewkies->col >= game.cols - 1) {
						mewkies->dir = DIR_LF;
						goto L_REDO;
					}
					break;
				default:
					DIE();
				}
			} else if(i_pat < N_MOVE) {
				/* XvCgƍW𒲐܂B */
				sprno += p_move[i_pat];
				f = fidiv(fld(i_pat), N_MOVE);
				switch(mewkies->dir) {
				case DIR_DN: mewkies->y = fadd(mewkies->y, f); break;
				case DIR_UP: mewkies->y = fsub(mewkies->y, f); break;
				case DIR_LF: mewkies->x = fsub(mewkies->x, f); break;
				case DIR_RI: mewkies->x = fadd(mewkies->x, f); break;
				default: DIE();
				}
				f = fimul(fsin(fidiv(fimul(PI, i_pat), N_MOVE)), MOVE_Z);
				mewkies->z = fadd(mewkies->z, f);
			} else {
				/* 1Z̈ړ܂B */
				mewkies->cnt = fld(0);
				switch(mewkies->dir) {
				case DIR_DN: mewkies->row++; break;
				case DIR_UP: mewkies->row--; break;
				case DIR_LF: mewkies->col--; break;
				case DIR_RI: mewkies->col++; break;
				default: DIE();
				}
				goto L_REDO;
			}

			break;

		default:
			DIE();
		}

		/* OBJo^܂B */
		obj_put(mewkies->x, mewkies->y, mewkies->z, sprno);
	}
}

/****************************************************************************
 *	ancestor_action
 ****************************************************************************/

void
ancestor_action()
{
	ANCESTOR* ancestor = &game.ancestor;
	int sprno;
	int i;
	int dir;
	int idir;
	int col;
	int row;
	int diff;
	int idiff;

	if(ancestor->stat == ANCESTOR_BLANK) return; /*  */
	if(ancestor->stat != ANCESTOR_MOVE) DIE();

	/* JE^i߂܂B */
	ancestor->cnt = fadd(ancestor->cnt, ancestor->speed);

	/* ZE𒴂... */
	while(ficom(ancestor->cnt, >=, 1)) {
		ancestor->cnt = fisub(ancestor->cnt, 1);

		/* ZړB */
		switch(ancestor->dir) {
		case DIR_DN: ancestor->row++; break;
		case DIR_UP: ancestor->row--; break;
		case DIR_LF: ancestor->col--; break;
		case DIR_RI: ancestor->col++; break;
		default: DIE();
		}

		/* ̕B */
		dir = -1;
		diff = 0; /* x} */
		for(i = 0; i < 4; i++) {
			idir = (ancestor->dir + i) & 3;
			if(idir == (ancestor->dir ^ 1)) continue; /* ނ͖ */
			col = ancestor->col;
			row = ancestor->row;
			switch(idir) {
			case DIR_DN: row++; break;
			case DIR_UP: row--; break;
			case DIR_LF: col--; break;
			case DIR_RI: col++; break;
			default: DIE();
			}
			if((col < 0) || (col > game.cols - 1) ||
			   (row < 0) || (row > game.rows - 1)) continue; /* ʊO */
			idiff = abs(game.mappy.col - col) +
				abs(game.mappy.row - row);
			if((dir == -1) || (idiff < diff)) {
				dir = idir;
				diff = idiff;
			}
		}
		if(dir != -1) { /* 肦Ȃ... */
			ancestor->dir = dir;
		}
	}

	/* OBJo^܂B */
	sprno = SPR_A00 + ((now / 4) & 3);
	ancestor->x = fld(ancestor->col);
	ancestor->y = fld(ancestor->row);
	switch(ancestor->dir) {
	case DIR_DN: ancestor->y = fadd(ancestor->y, ancestor->cnt); break;
	case DIR_UP: ancestor->y = fsub(ancestor->y, ancestor->cnt); break;
	case DIR_LF: ancestor->x = fsub(ancestor->x, ancestor->cnt); break;
	case DIR_RI: ancestor->x = fadd(ancestor->x, ancestor->cnt); break;
	default: DIE();
	}
	obj_put(ancestor->x, ancestor->y, 0, sprno);
}

/****************************************************************************
 *	target_action
 ****************************************************************************/

void
target_action()
{
	TARGET* target;
	int i_target;
	int sprno;

	for(i_target = 0, target = game.target;
	    i_target < MAX_TARGET;
	    i_target++, target++) {

		if(target->stat == TARGET_BLANK) continue; /*  */

		/* XvCgƍW߂Ă܂B */
		sprno = SPR_T00 + target->kind * 2;
		target->x = fld(target->col);
		target->y = fld(target->row);

		/* Ԃɂ... */
		switch(target->stat) {

		/*** ʏ ***/
		case TARGET_NORMAL:

			/* A^[QbgȂ΁AAj[VB */
			if(target->kind == game.kind) {
				if(now % SEC(0.5) < SEC(0.25)) {
					sprno++;
				}
			}

			break;

		/*** |Cg\ ***/
		case TARGET_POINT:

			/* JE^i߂܂B */
			target->cnt++;

			/* 莞Ԍo߂Ał܂B */
			if(target->cnt >= SEC(2)) {
				target->stat = TARGET_BLANK;
				goto L_NEXT;
			}

			/* XvCgݒ肵܂B */
			sprno = SPR_P00 + target->kind * 5 + target->mult;

			break;

		default:
			DIE();
		}

		/* OBJo^܂B */
		obj_put(target->x, target->y, 0, sprno);
L_NEXT:
	}
}
